#include"mqttjson.h"
#include "ip.h"
#include "serial.h"

int keepRunning = 1;
const int gmiddlepwm=0;


// 睡眠毫秒
void sleepms(){
    struct timespec ts;
    ts.tv_sec = 0; // 秒
    ts.tv_nsec = 1000000; // 纳秒，0.5秒等于500,000,000纳秒
    nanosleep(&ts, NULL);
   
}

void sleepmsv2(int val){
    struct timespec ts;
    ts.tv_sec = 0; // 秒
    ts.tv_nsec = val*1000000; // 纳秒，0.5秒等于500,000,000纳秒
    nanosleep(&ts, NULL);
   
}

void *usar_Receive(void *arg)
{
    printf("serial receive runing");
    serial_Receive();
    return NULL;
}

void *left_function(void *arg)
{ 
    printf("Thread speed is runing\n");
    while(keepRunning){
        sleepmsv2(1);
        gLeftPwmCount++;
        //printf("gLeftPwmCount:%d\n",gLeftPwmCount);
        
        if (gLeftPwmCount>200){
            //printf("mid:%d \n",gmiddlepwm);
            pwmWrite(gLeftPwmPin,gmiddlepwm);  //中间
            // digitalWrite(Pin_left1,LOW);
            // digitalWrite(Pin_left2,LOW);
            gLeftPwmCount = 201;
        } else{
            int pwm1 = gLeftPwm*9;
              //gLeftPwm(0-100)
            pwmWrite(gLeftPwmPin,pwm1);  //0-150-300
            //printf("gLeftPwm:%d,pwm:%d\n",gLeftPwm,pwm1);
        }
    }   
    return NULL; 
}

void *right_function(void *arg)
{ 
     while(keepRunning){
        sleepmsv2(1);
        gRightPwmCount++;
        if (gRightPwmCount>200){
            pwmWrite(gRightPwmPin,gmiddlepwm);  //中间
            gRightPwmCount=2001;
        } else{ 
            int pwm2 = gRightPwm*9;  //gLeftPwm(0-100)          
            pwmWrite(gRightPwmPin,pwm2);  //0-150-300
        }
    }   
    return NULL; 
}


int main(int argc, char *argv[]) {
    
    
    gStart=time(NULL);
    // 初始化 mosquitto 库
    mosquitto_lib_init();

    mqtt_Init();
    
   serial_Init();

    ipaddr();
    //mqtt_wirte(ip_address);
    //printf("%s\n",ip_address);
   //mosquitto_publish(mosq, NULL, "controlship/02", strlen(ip_address), ip_address, 0, false);//将ip发送给mqtt

    if (wiringPiSetup()== -1) {
        printf("pin set fail\n");
        return 1;
    }
    
    setinit();
    

    pinMode(gLeftPwmPin,PWM_OUTPUT);
    pwmSetClock(gLeftPwmPin,328);//=19200*1000/(hz*2000)
    pwmSetRange(gLeftPwmPin,1000);

    pinMode(gRightPwmPin,PWM_OUTPUT);
    pwmSetClock(gRightPwmPin,328);//=19200*1000/(hz*2000)
    pwmSetRange(gRightPwmPin,1000);

    pthread_t thread[3];

    if(pthread_create(&thread[0],NULL,left_function,NULL)!=0)
    {
        perror("Failed to create thread 1");
        return 1;
    }

    if(pthread_create(&thread[1],NULL,right_function,NULL)!=0)
    {
        perror("Failed to create thread 1");
        return 1;
    }

    if(pthread_create(&thread[2],NULL,usar_Receive,NULL)!=0)
    {
        perror("Failed to create thread 1");
        return 1;
    }
    

    // 开始循环，处理网络流量
    mosquitto_loop_forever(mosq, -1, 1); // -1 表示无限等待，1 表示处理消息的最大数量

    // 清理
    mosquitto_destroy(mosq);
    mosquitto_lib_cleanup(); 
    // 等待线程1结束
    pthread_join(thread[0], NULL);

    // 等待线程2结束
    pthread_join(thread[1], NULL);

        return EXIT_SUCCESS;
}