#include "mqttjson.h"
#include "ip.h"

time_t gStart;

int gmqttindex=0;

struct mosquitto *mosq;

int gLeftPwmPin = 21;
int gLeftPwm = 0;
int gLeftPwmCount = 0;  // 计数

int gRightPwmPin = 2;
int gRightPwm = 0;
int gRightPwmCount = 0;  // 计数

cJSON *root;
char *payload;


void mqtt_wirte()
{
    root = cJSON_CreateObject();
    cJSON *body = cJSON_AddObjectToObject(root, "body");
    cJSON *data = cJSON_AddArrayToObject(body, "data");
    cJSON *data_item = cJSON_CreateObject();
    cJSON_AddStringToObject(data_item, "ip", ip_address);
    cJSON_AddStringToObject(data_item, "ID", TOPIC);
    cJSON_AddStringToObject(data_item, "N", lat);
    cJSON_AddStringToObject(data_item, "E", lon);
     
    //printf("%d\n",gmqttcount);
    if(gmqttcount>=10)
    {
        gmqttindex=0;
        gmqttcount=11;
        cJSON_AddStringToObject(data_item, "connectfail", "-1");
         
    }
    cJSON_AddItemToArray(data, data_item); 
    payload = cJSON_PrintUnformatted(root);
    if(gmqttindex==0)
    {
       mosquitto_publish(mosq, NULL, TOPIC, strlen(payload), payload, 0, false); 
    }
      

}

int mqtt_Init()
{
    int rc;
      // 创建 mosquitto 客户端
    mosq = mosquitto_new(CLIENT_ID, true, NULL);
    if (!mosq) {
        fprintf(stderr, "Failed to create mosquitto client\n");
        return EXIT_FAILURE;
    }

    // 设置连接和消息回调
    mosquitto_connect_callback_set(mosq, on_connect);
    mosquitto_message_callback_set(mosq, on_message);

    // 设置用户名和密码
    mosquitto_username_pw_set(mosq, USERNAME, PASSWORD);
    // 连接到 MQTT 代理
    rc = mosquitto_connect(mosq, BROKER_ADDRESS, BROKER_PORT, 60);
    if (rc != MOSQ_ERR_SUCCESS) {
        fprintf(stderr, "Failed to connect to broker: %s\n", mosquitto_strerror(rc));
        mosquitto_destroy(mosq);
        return EXIT_FAILURE;
    }
}

void on_connect(struct mosquitto *mosq, void *obj, int rc) 
{
    if (rc == 0) 
    {
     printf("Connected to broker\n");
     mosquitto_subscribe(mosq, NULL, TOPIC, 0);
     //time_t start=time(NULL);
     gmqttindex=0;
    } 
    else 
    {
    fprintf(stderr, "Connection failed with code %d\n", rc);
    }
}

void on_message(struct mosquitto *mosq, void *obj, const struct mosquitto_message *message) {
    
    time_t end = time(NULL);
    if(gStart+5>end)
    {
        printf("正在处理过期消息");
        return;
        
    }
    
    // 确保消息有效
    if (message->payload && message->payloadlen) {  
        
        // 将消息内容转换为字符串
        char *payload_str = (char *)malloc(message->payloadlen + 1);
        if (payload_str) {
            memcpy(payload_str, message->payload, message->payloadlen);
            payload_str[message->payloadlen] = '\0';
            // 解析 JSON
            cJSON *json = cJSON_Parse(payload_str);
            if (json == NULL) {
                fprintf(stderr, "Error before: [%s]\n", cJSON_GetErrorPtr());
            } else {
                // 提取 head 对象
                cJSON *head = cJSON_GetObjectItem(json, "head");
                if (!cJSON_IsObject(head)) {
                    return;
                }
                // 提取 message_type
                cJSON *message_type = cJSON_GetObjectItem(head, "message_type");
                if (!cJSON_IsNumber(message_type)) {
                    return;
                }
                cJSON *body = cJSON_GetObjectItem(json, "body");
                if (!cJSON_IsObject(body)) {
                    return;
                }
                gmqttcount=0;//接收到消息，就表示在连接
                printf("message_type: %d\n", message_type->valueint);
                if (message_type->valueint==3){  //pwm控制
                    // 提取 pin_ctrl_req 对象
                    cJSON *pwm_ctrl_req = cJSON_GetObjectItem(body, "p_ctrl_req");
                    if (!cJSON_IsObject(pwm_ctrl_req)) {
                        return;
                    }
                    // 提取 data 数组
                    cJSON *data = cJSON_GetObjectItem(pwm_ctrl_req, "data");
                    if (!cJSON_IsArray(data)) {
                        return;
                    }
                    
                    // 遍历数组
                    for (int i = 0; i < cJSON_GetArraySize(data); ++i) {
                        // 提取数组中的每个对象
                        cJSON *item = cJSON_GetArrayItem(data, i);
                        if (!cJSON_IsObject(item)) {
                            continue;
                        }
                        cJSON *mode = cJSON_GetObjectItem(item, "mode");   //mode=1 左前，mode=2 右前，3 左后，4 右后
                        //cJSON *pin = cJSON_GetObjectItem(item, "pin");
                        cJSON *val = cJSON_GetObjectItem(item, "val");  //val为pwm的值 0~100
                        int modeTemp = mode->valueint;
                        int valTemp = val->valueint;
                        printf("mode:%d,val:%d\n",modeTemp,valTemp);
                        if (modeTemp==1){
                            leftFront();
                            gLeftPwmCount = 0;
                            gLeftPwm = valTemp;
                            printf("gLeftPwmPin pin:%d ,gLeftPwm:%d\n",gLeftPwmPin,gLeftPwm);
                        }else if(modeTemp==2){
                            rightFront();
                            gRightPwmCount = 0; 
                            gRightPwm = valTemp;
                            printf("gRightPwmPin pin:%d ,gRightPwm:%d\n",gRightPwmPin,gRightPwm);
                        }else if(modeTemp==3){
                            leftBack();
                            gLeftPwmCount = 0;
                            gLeftPwm = valTemp;
                            printf("gLeftPwmPin pin:%d ,gLeftPwm:%d\n",gLeftPwmPin,gLeftPwm);
                        }else if(modeTemp==4){
                             rightBack();
                            gRightPwmCount = 0; 
                            gRightPwm = valTemp;
                            printf("gRightPwmPin pin:%d ,gRightPwm:%d\n",gRightPwmPin,gRightPwm);
                        }
                        
                    }
                }
                else if (message_type->valueint==4){
                    // 提取 pin_ctrl_req 对象
                    cJSON *pin_ctrl_req = cJSON_GetObjectItem(body, "p_ctrl_req");
                    if (!cJSON_IsObject(pin_ctrl_req)) {
                        return;
                    }
                    // 提取 data 数组
                    cJSON *data = cJSON_GetObjectItem(pin_ctrl_req, "data");
                    if (!cJSON_IsArray(data)) {
                        return;
                    }
                    // 遍历数组
                    for (int i = 0; i < cJSON_GetArraySize(data); ++i) {
                        // 提取数组中的每个对象
                        cJSON *item = cJSON_GetArrayItem(data, i);
                        if (!cJSON_IsObject(item)) {
                            continue;
                        }
                        // 提取 pin
                        cJSON *pin = cJSON_GetObjectItem(item, "pin");
                        cJSON *val = cJSON_GetObjectItem(item, "val");
                        int pinTemp = pin->valueint;
                        int valTemp = val->valueint;
                        //printf("12");
                        // 在这里控制IO口
                        pinvalue(pinTemp,valTemp);
                    }
                }
                else if (message_type->valueint==5)
                {
                    mqtt_wirte();
                    mosquitto_publish(mosq, NULL, TOPIC, strlen(payload), payload, 0, false); 
                }
                else if (message_type->valueint==0)
                {
                    gmqttindex=1;
                    
                }

            }

            // 释放 payload 字符串
            free(payload_str);
        }
    }
}
    
